//
//  ViewController.m
//  UserDefault
//
//  Created by akash on 3/8/16.
//  Copyright (c) 2016 evon. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
{
    NSArray *recordsFromUserDef;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)btnSaveInDatabase:(id)sender {
    EmpModel *model = [[EmpModel alloc] init];
    [model setEmpName:txtName.text];
    [model setEmpAddress:txtAddress.text];
    [model setEmpPhoneNumber:txtPhone.text];
    [model setEmpEmail:txtEmail.text];

    [[DataBaseManager sharedDatabaseManager] saveEmployeeRecordToDB:model];
}

- (IBAction)btnSave:(id)sender {
    
    
    if(txtName.text.length>5 && txtDepartment.text.length>5)
    {
    
    NSUserDefaults *userDef = [NSUserDefaults standardUserDefaults];
    
    NSArray *recordArrFromDef = [userDef objectForKey:@"recordArray"]; // get array from user default
    
    // array fetched from userdefault is not mutable
    // so create a mutable array
    
    NSMutableArray *mutableArr;
    
    if (!recordArrFromDef) { // if no array in user default create new mutable array
        mutableArr = [NSMutableArray new];
    } else { // if array present in user default then create mutable copy
        mutableArr = [recordArrFromDef mutableCopy];
    }
    
    // create mutable dictionary for record
    NSMutableDictionary *recordDic = [NSMutableDictionary new];
    
    [recordDic setObject:txtName.text forKey:@"name"];
    [recordDic setObject:txtDepartment.text forKey:@"department"];
    
    NSLog(@"recorddict %@",recordDic);
    
    // save the dictionary to mutable array
    
    [mutableArr addObject:recordDic];
    
    // save the array to userdefaults
    
    [userDef setObject:mutableArr forKey:@"recordArray"];
    
    // synchronize
    [userDef synchronize];
    }
    else{
        NSString *message=[NSString stringWithFormat:@"%@",@"Please fill both fields"];
        UIAlertController *alert=[UIAlertController alertControllerWithTitle:@"Message" message:message preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction *dismiss=[UIAlertAction actionWithTitle:@"Dismiss" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action) {
            
        }];
        [alert addAction:dismiss];
        [self presentViewController:alert  animated:YES completion:nil];
    }
    txtName.text=@"";
    txtDepartment.text=@"";
    
}

- (IBAction)btnViewRecord:(id)sender {
  recordsFromUserDef = [[NSUserDefaults standardUserDefaults] objectForKey:@"recordArray"];
//    NSLog(@"records in userdef %@",recordsFromUserDef);
         [self performSegueWithIdentifier:@"RecordView" sender:nil];

}

- (IBAction)btnGetDataFromDatabase:(id)sender {
     [self performSegueWithIdentifier:@"RecordView" sender:nil];
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    
    if ([segue.identifier isEqualToString:@"RecordView"]) {
        //RecordViewController *nextVC=[segue destinationViewController];
   
    }
}
@end
